#include "crect.h"

CRect::CRect()
{
	SetRectEmpty();
}

CRect::CRect(double l, double t, double r, double b)
{
	left = l;
	top = t;
	right = r;
	bottom = b;
}

bool CRect::IsRectNull()
{
	return !(left || right || top || bottom);
}

bool CRect::IsRectEmpty()
{
	return (Width() <= 0 || Height() <= 0);
}

void CRect::SetRectEmpty()
{
	left = right = top = bottom = 0;
}

void CRect::IntersectRect(const CRect &rect1, const CRect &rect2)
{
	left = rect1.left > rect2.left ? rect1.left : rect2.left;
	right = rect1.right < rect2.right ? rect1.right : rect2.right;
	top = rect1.top > rect2.top ? rect1.top : rect2.top;
	bottom = rect1.bottom < rect2.bottom ? rect1.bottom : rect2.bottom;

}

void CRect::NormalizeRect()
{
	double temp;
	if (left > right)
	{
		temp = left;
		left = right;
		right = temp;
	}
	if (bottom < top)
	{ // may seem odd, but this is what the MFC version does
		temp = bottom;
		bottom = top;
		top = temp;
	}
}

bool CRect::PtInRect(double x, double y)
{
	return (x < right && x > left && 
			y > top && y < bottom);
}

double CRect::Width()
{
	return (right - left);
}

double CRect::Height()
{
	return (bottom - top);
}
