#ifndef __tokenizer_h
#define __tokenizer_h

#include <wx/string.h>

class Tokenizer
{
public:
	Tokenizer();
	Tokenizer(const wxString &s);
	Tokenizer(const wxString &s, const wxString &dlms);
	~Tokenizer();
	
	bool isEmpty();
	bool get(wxString &tok);
	bool unget();
	void clearQueue();
	
	bool hasTokens();
	wxString next();
	
	int getCurrentPos();
	int getLastTokenEndPos();
	wxString getRestOfInput();

	void reset(const wxString &s);

	void setDelimiters(const wxString &dlms);
	wxString getDelimiters();

private:
	wxString str;
	wxString delims;
	int last_pos;
	int pos;
	
	void pump();
	
	struct Token
	{
		Token *next;
		Token *prev;
		wxString str;
	};
	
	Token *head;
	Token *tail;
	Token *cur;
};

#endif
